Package org.flowable.task.api.history

# Interface HistoricTaskInstanceQuery

All Superinterfaces:
  `DeleteQuery<HistoricTaskInstanceQuery,HistoricTaskInstance>`, `Query<HistoricTaskInstanceQuery,HistoricTaskInstance>`, `TaskInfoQuery<HistoricTaskInstanceQuery,HistoricTaskInstance>`

public interface HistoricTaskInstanceQuery extends TaskInfoQuery<HistoricTaskInstanceQuery,HistoricTaskInstance>, DeleteQuery<HistoricTaskInstanceQuery,HistoricTaskInstance>
Allows programmatic querying for `HistoricTaskInstance`s.

Author:
  Tom Baeyens, Joram Barrez

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface org.flowable.common.engine.api.query.Query

  `Query.NullHandlingOnOrder`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `HistoricTaskInstanceQuery`
  `finished()`
  Only select historic task instances which are finished.
  `HistoricTaskInstanceQuery`
  `orderByDeleteReason()`
  Order by task delete reason (needs to be followed by `Query.asc()` or `Query.desc()`).
  `HistoricTaskInstanceQuery`
  `orderByHistoricActivityInstanceId()`
  Order by the historic activity instance id this task was used in (needs to be followed by `Query.asc()` or `Query.desc()`).
  `HistoricTaskInstanceQuery`
  `orderByHistoricTaskInstanceDuration()`
  Order by duration (needs to be followed by `Query.asc()` or `Query.desc()`).
  `HistoricTaskInstanceQuery`
  `orderByHistoricTaskInstanceEndTime()`
  Order by end time (needs to be followed by `Query.asc()` or `Query.desc()`).
  `HistoricTaskInstanceQuery`
  `orderByHistoricTaskInstanceStartTime()`
  Order by start time (needs to be followed by `Query.asc()` or `Query.desc()`).
  `HistoricTaskInstanceQuery`
  `processFinished()`
  Only select historic task instances which are part of a process instance which is already finished.
  `HistoricTaskInstanceQuery`
  `processUnfinished()`
  Only select historic task instances which are part of a process instance which is not finished yet.
  `HistoricTaskInstanceQuery`
  `taskCompletedAfter(Date endDate)`
  Only select historic task instances which are completed after the given date
  `HistoricTaskInstanceQuery`
  `taskCompletedBefore(Date endDate)`
  Only select historic task instances which are completed before the given date
  `HistoricTaskInstanceQuery`
  `taskCompletedBy(String userId)`
  Only select historic task instances which are completed by the given user
  `HistoricTaskInstanceQuery`
  `taskCompletedOn(Date endDate)`
  Only select historic task instances which are completed on the given date
  `HistoricTaskInstanceQuery`
  `taskDeleteReason(String taskDeleteReason)`
  Only select historic task instances with the given task delete reason.
  `HistoricTaskInstanceQuery`
  `taskDeleteReasonLike(String taskDeleteReasonLike)`
  Only select historic task instances with a task description like the given value.
  `HistoricTaskInstanceQuery`
  `taskParentTaskId(String parentTaskId)`
  Only select subtasks of the given parent task
  `HistoricTaskInstanceQuery`
  `taskWithoutDeleteReason()`
  Only select historic tasks without a delete reason (completed normally)
  `HistoricTaskInstanceQuery`
  `unfinished()`
  Only select historic task instances which aren't finished yet.

  ### Methods inherited from interface org.flowable.common.engine.api.query.DeleteQuery

  `delete, deleteWithRelatedData`

  ### Methods inherited from interface org.flowable.common.engine.api.query.Query

  `asc, count, desc, list, listPage, orderBy, orderBy, singleResult`

  ### Methods inherited from interface org.flowable.task.api.TaskInfoQuery

  `caseDefinitionId, caseDefinitionKey, caseDefinitionKeyIn, caseDefinitionKeyLike, caseDefinitionKeyLikeIgnoreCase, caseInstanceId, caseInstanceIdWithChildren, caseVariableExists, caseVariableNotExists, caseVariableValueEquals, caseVariableValueEquals, caseVariableValueEqualsIgnoreCase, caseVariableValueGreaterThan, caseVariableValueGreaterThanOrEqual, caseVariableValueLessThan, caseVariableValueLessThanOrEqual, caseVariableValueLike, caseVariableValueLikeIgnoreCase, caseVariableValueNotEquals, caseVariableValueNotEqualsIgnoreCase, cmmnDeploymentId, cmmnDeploymentIdIn, deploymentId, deploymentIdIn, endOr, executionId, ignoreAssigneeValue, includeCaseVariables, includeIdentityLinks, includeProcessVariables, includeTaskLocalVariables, locale, or, orderByCategory, orderByDueDateNullsFirst, orderByDueDateNullsLast, orderByExecutionId, orderByProcessDefinitionId, orderByProcessInstanceId, orderByTaskAssignee, orderByTaskCreateTime, orderByTaskDefinitionKey, orderByTaskDescription, orderByTaskDueDate, orderByTaskId, orderByTaskName, orderByTaskOwner, orderByTaskPriority, orderByTenantId, planItemInstanceId, processCategoryIn, processCategoryNotIn, processDefinitionId, processDefinitionKey, processDefinitionKeyIn, processDefinitionKeyLike, processDefinitionKeyLikeIgnoreCase, processDefinitionName, processDefinitionNameLike, processInstanceBusinessKey, processInstanceBusinessKeyLike, processInstanceBusinessKeyLikeIgnoreCase, processInstanceId, processInstanceIdIn, processInstanceIdWithChildren, processVariableExists, processVariableNotExists, processVariableValueEquals, processVariableValueEquals, processVariableValueEqualsIgnoreCase, processVariableValueGreaterThan, processVariableValueGreaterThanOrEqual, processVariableValueLessThan, processVariableValueLessThanOrEqual, processVariableValueLike, processVariableValueLikeIgnoreCase, processVariableValueNotEquals, processVariableValueNotEqualsIgnoreCase, propagatedStageInstanceId, scopeDefinitionId, scopeId, scopeType, subScopeId, taskAssigned, taskAssignee, taskAssigneeIds, taskAssigneeLike, taskAssigneeLikeIgnoreCase, taskCandidateGroup, taskCandidateGroupIn, taskCandidateUser, taskCategory, taskCategoryIn, taskCategoryNotIn, taskClaimedAfter, taskClaimedBefore, taskClaimedBy, taskClaimedOn, taskCreatedAfter, taskCreatedBefore, taskCreatedOn, taskDefinitionId, taskDefinitionKey, taskDefinitionKeyLike, taskDefinitionKeys, taskDescription, taskDescriptionLike, taskDescriptionLikeIgnoreCase, taskDueAfter, taskDueBefore, taskDueDate, taskFormKey, taskId, taskIds, taskInProgressStartDueAfter, taskInProgressStartDueBefore, taskInProgressStartDueDate, taskInProgressStartedBy, taskInProgressStartTimeAfter, taskInProgressStartTimeBefore, taskInProgressStartTimeOn, taskInvolvedGroups, taskInvolvedUser, taskMaxPriority, taskMinPriority, taskName, taskNameIn, taskNameInIgnoreCase, taskNameLike, taskNameLikeIgnoreCase, taskOwner, taskOwnerLike, taskOwnerLikeIgnoreCase, taskParentScopeId, taskPriority, taskRootScopeId, taskState, taskSuspendedAfter, taskSuspendedBefore, taskSuspendedBy, taskSuspendedOn, taskTenantId, taskTenantIdLike, taskUnassigned, taskVariableExists, taskVariableNotExists, taskVariableValueEquals, taskVariableValueEquals, taskVariableValueEqualsIgnoreCase, taskVariableValueGreaterThan, taskVariableValueGreaterThanOrEqual, taskVariableValueLessThan, taskVariableValueLessThanOrEqual, taskVariableValueLike, taskVariableValueLikeIgnoreCase, taskVariableValueNotEquals, taskVariableValueNotEqualsIgnoreCase, taskWithFormKey, taskWithoutCategory, taskWithoutTenantId, withLocalizationFallback, withoutProcessInstanceId, withoutScopeId, withoutTaskDueDate, withoutTaskInProgressStartDueDate`

- ## Method Details

  - ### taskDeleteReason

    HistoricTaskInstanceQuery taskDeleteReason(String taskDeleteReason)
    Only select historic task instances with the given task delete reason.

  - ### taskDeleteReasonLike

    HistoricTaskInstanceQuery taskDeleteReasonLike(String taskDeleteReasonLike)
    Only select historic task instances with a task description like the given value. The syntax that should be used is the same as in SQL, eg. %test%.

  - ### finished

    HistoricTaskInstanceQuery finished()
    Only select historic task instances which are finished.

  - ### unfinished

    HistoricTaskInstanceQuery unfinished()
    Only select historic task instances which aren't finished yet.

  - ### processFinished

    HistoricTaskInstanceQuery processFinished()
    Only select historic task instances which are part of a process instance which is already finished.

  - ### processUnfinished

    HistoricTaskInstanceQuery processUnfinished()
    Only select historic task instances which are part of a process instance which is not finished yet.

  - ### taskParentTaskId

    HistoricTaskInstanceQuery taskParentTaskId(String parentTaskId)
    Only select subtasks of the given parent task

  - ### taskCompletedOn

    HistoricTaskInstanceQuery taskCompletedOn(Date endDate)
    Only select historic task instances which are completed on the given date

  - ### taskCompletedBefore

    HistoricTaskInstanceQuery taskCompletedBefore(Date endDate)
    Only select historic task instances which are completed before the given date

  - ### taskCompletedAfter

    HistoricTaskInstanceQuery taskCompletedAfter(Date endDate)
    Only select historic task instances which are completed after the given date

  - ### taskCompletedBy

    HistoricTaskInstanceQuery taskCompletedBy(String userId)
    Only select historic task instances which are completed by the given user

  - ### taskWithoutDeleteReason

    HistoricTaskInstanceQuery taskWithoutDeleteReason()
    Only select historic tasks without a delete reason (completed normally)

  - ### orderByHistoricActivityInstanceId

    HistoricTaskInstanceQuery orderByHistoricActivityInstanceId()
    Order by the historic activity instance id this task was used in (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByHistoricTaskInstanceDuration

    HistoricTaskInstanceQuery orderByHistoricTaskInstanceDuration()
    Order by duration (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByHistoricTaskInstanceEndTime

    HistoricTaskInstanceQuery orderByHistoricTaskInstanceEndTime()
    Order by end time (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByHistoricTaskInstanceStartTime

    HistoricTaskInstanceQuery orderByHistoricTaskInstanceStartTime()
    Order by start time (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByDeleteReason

    HistoricTaskInstanceQuery orderByDeleteReason()
    Order by task delete reason (needs to be followed by `Query.asc()` or `Query.desc()`).